﻿using System;
using System.Numerics;
using System.Windows.Forms;
using Fibonacci.Model;

namespace Fibonacci.View
{
    public partial class MainForm : Form
    {
        private Calculator calc;
        private Boolean isRunning = false;

        public MainForm()
        {
            InitializeComponent();

            calc = new Calculator();
            calc.NewResult += GotNewResult;
            calc.Ready += Ready;
        }

        private void StartStop(object sender, EventArgs e)
        {
            if (!isRunning)
            {
                _lbxResults.Items.Clear();
                _btnCalculate.Text = "Leállít";
                isRunning = true;

                calc.Run(Convert.ToInt32(_nupN.Value));
            }
            else
                calc.Cancel();
        }

        private void GotNewResult(Int32 n, BigInteger result)
        {
            if (_lbxResults.InvokeRequired)
            {
                Invoke(new NewResultEventHandler(GotNewResult), n, result);
                return;
            }
            _lbxResults.Items.Insert(0, n + ": " + result);
        }

        private void Ready(object sender, EventArgs e)
        {
            if (_btnCalculate.InvokeRequired)
            {
                Invoke(new EventHandler(Ready), sender, e);
                return;
            }
            _btnCalculate.Text = "Számol";
            isRunning = false;
        }
    }
}
